﻿using System;
using System.ComponentModel;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using Microsoft.SharePoint;
using Microsoft.SharePoint.WebControls;
using Microsoft.Office.RecordsManagement.RecordsRepository;

namespace WingtipToysContentOrganizer.CORulesWebPart
{
    [ToolboxItemAttribute(false)]
    public class CORulesWebPart : WebPart
    {
        // Visual Studio might automatically update this path when you change the Visual Web Part project item.
        private const string _ascxPath = @"~/_CONTROLTEMPLATES/WingtipToysContentOrganizer/CORulesWebPart/CORulesWebPartUserControl.ascx";
        


        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);

            try
            {
SPSite currentSite = new SPSite("http://teamsite.wingtiptoys.com/");
SPWeb currentWeb = currentSite.OpenWeb();
currentWeb.AllowUnsafeUpdates = true;

EcmDocumentRoutingWeb contentOrganizerWeb = new EcmDocumentRoutingWeb(currentWeb);

EcmDocumentRouterRule newRule = new EcmDocumentRouterRule(currentWeb);
newRule.Name = "Spreadsheets";
newRule.Priority = "5";

SPContentType documentContentType = currentWeb.ContentTypes["Document"];
newRule.ContentTypeString = documentContentType.Name;

SPField documentTypeField = currentWeb.Fields.GetField("Document Type");
string ruleOperator = "IsEqual";
string ruleValue = "Spreadsheet";
string conditionString = String.Format(@"<Condition 
Column=""{0}|{1}|{2}"" Operator=""{3}"" Value=""{4}"" />",
    documentTypeField.Id, documentTypeField.InternalName, documentTypeField.Title, ruleOperator, ruleValue);
string conditionsXml = String.Format("<Conditions>{0}</Conditions>", conditionString);

newRule.ConditionsString = conditionsXml;

SPList spreadSheetLibrary = currentWeb.Lists["Spreadsheets"];
newRule.TargetPath = spreadSheetLibrary.RootFolder.ServerRelativeUrl;

newRule.Enabled = true;

contentOrganizerWeb.RoutingRuleCollection.Add(newRule);
currentWeb.AllowUnsafeUpdates = false;

currentWeb.Dispose();
currentSite.Dispose();

            }
            catch (Exception ex)
            {
                
            }

        }
    }
}
